package sample.diff;

import java.io.File;
import java.io.FileWriter;

import com.park.lib.diff.Diff;
import com.park.lib.diff.DiffResult;

/**
 * DIFFeXgpvOB
 * 
 * @author iwama
 *
 */
public class DiffTest {
	
	/**
	 * eXgpvOCB
	 * 
	 * @param args
	 * @throws Exception
	 */
	public static void main(String[] args) throws Exception {

		String textA = null;
		String textB = null;
		
		textA = "\r\n\r\n\r\n\r\n";
		textB = "\r\n\r\n\r\n\r\n\r\n\r\n";

		System.out.println("---------- textA ----------");
		System.out.println(textA);
		System.out.println("---------------------------");
		System.out.println("---------- textB ----------");
		System.out.println(textB);
		System.out.println("---------------------------");
		
		diffChar(textA, textB);
		diffLine(textA, textB);
	}
	
	/**
	 * Pʂ̍os郁\bhB
	 * 
	 * @param textA
	 * @param textB
	 * @throws Exception
	 */
	private static void diffChar(String textA, String textB) throws Exception {

		System.out.println("\nDiff Char ----------------------------------------------------------------------");
		Diff diff = new Diff();
		DiffResult[] ret = diff.DiffChar(textA, textB);
		System.out.println("Result Num = " + ret.length);
		DiffResult result = null;
		for(int i = 0; i < ret.length; i++) {
			result = ret[i];
			System.out.println("  result[" + i + "]");
			System.out.println("    Modified       : " + result.Modified);
			System.out.println("    ModifiedLength : " + result.ModifiedLength);
			System.out.println("    ModifiedStart  : " + result.ModifiedStart);
			System.out.println("    OriginalLength : " + result.OriginalLength);
			System.out.println("    OriginalStart  : " + result.OriginalStart);
		}
		
		String htmlStr = HTMLConvert.convert(textA, textB, ret);
		writeHTML(htmlStr, ".\\diffChar.html");
		
		return;
	}

	/**
	 * sPʂ̍os\bhB
	 * 
	 * @param textA
	 * @param textB
	 * @throws Exception
	 */
	private static void diffLine(String textA, String textB) throws Exception {

		System.out.println("\nDiff Line ----------------------------------------------------------------------");
		Diff diff = new Diff();
		DiffResult[] ret = diff.DiffLine(textA, textB);
		System.out.println("Result Num = " + ret.length);
		DiffResult result = null;
		for(int i = 0; i < ret.length; i++) {
			result = ret[i];
			System.out.println("  result[" + i + "]");
			System.out.println("    Modified       : " + result.Modified);
			System.out.println("    ModifiedLength : " + result.ModifiedLength);
			System.out.println("    ModifiedStart  : " + result.ModifiedStart);
			System.out.println("    OriginalLength : " + result.OriginalLength);
			System.out.println("    OriginalStart  : " + result.OriginalStart);
		}
		
		String htmlStr = HTMLConvert.convertLine(textA, textB, ret);
		writeHTML(htmlStr, ".\\diffLine.html");
		
		return;
	}
	
	/**
	 * HTMLt@Co̓\bhB
	 * ʏɕҏWHTML`̕t@C֏o͂B
	 * 
	 * @param data
	 * @throws Exception
	 */
	private static void writeHTML(String data, String fileName) throws Exception {
		File f = new File(fileName);
		FileWriter fw = null;
		try {
			fw = new FileWriter(f);
			fw.write(data);
		} catch(Exception e) {
			throw e;
		} finally {
			if(fw != null) {
				fw.close();
			}
		}
	}
}
