package sample.diff;

import java.util.LinkedList;
import java.util.List;

import com.park.lib.diff.DiffResult;


/**
 * HTMLϊNXB
 * DIFFʂHTML`֕̕ϊB
 */
public class HTMLConvert {

	public HTMLConvert() {
		super();
	}

	/**
	 * PʂDIFFʂHTML`̕ɕϊ郁\bhB
	 * 폜ꂽiCɂ폜܂ށj͏C֏𔽉fA
	 * ǉ^Cꂽ͏C֏𔽉fB
	 * 
	 * @param textA
	 * @param textB
	 * @param results
	 * @return
	 */
	public static String convertHtml(String textA, String textB, DiffResult[] results) {
		
		String ret = null;
		
		DiffResult result = null;
		for(int i = (results.length - 1); i >= 0; i--) {
			result = results[i];
			if(result.Modified == false) {
				continue;
			}

			if(result.isModified()) {
				textA = replaceItem(textA, result, true);
				textB = replaceItem(textB, result, false);
			} else if(result.isDelete()) {
				textA = replaceItem(textA, result, true);
			} else {
				textB = replaceItem(textB, result, false);
			}
		}
		
		ret =
			"<HTML>\n<HEAD>\n</HEAD>\n<BODY>\n" +
			"ύXOF<BR>" + textA.replaceAll("\r\n", "<BR>\n") +
			"<BR><BR>" +
			"ύXF<BR>" + textB.replaceAll("\r\n", "<BR>\n") +
			"</BODY>\n</HTML>";
		
		return ret;
	}
	
	/**
	 * PʂDIFFʂHTML`̕ɕϊ郁\bhB
	 * ǉ^폜^Cӏ̕\SďC֔fĕ\B
	 * 
	 * @param textA
	 * @param textB
	 * @param results
	 * @return
	 */
	public static String convert(String textA, String textB, DiffResult[] results) {
		
		String ret = null;
		
		DiffResult result = null;
		for(int i = (results.length - 1); i >= 0; i--) {
			result = results[i];
			if(result.Modified == false) {
				continue;
			}

			if(result.isModified()) {
				textB = replaceOrgInfo(textA, textB, result);
				textB = replaceToInfo(textB, result);
			} else if(result.isDelete()) {
				textB = replaceOrgInfo(textA, textB, result);
			} else {
				textB = replaceToInfo(textB, result);
			}
		}
		
		ret =
			"<HTML>\n<HEAD>\n</HEAD>\n<BODY>\n" +
			"ύXOF<BR>" + textA.replaceAll("\r\n", "<BR>\n") +
			"<BR><BR>" +
			"ύXF<BR>" + textB.replaceAll("\r\n", "<BR>\n") +
			"</BODY>\n</HTML>";
		
		
		return ret;
	}
	
	/**
	 * sPʂDIFFʂHTML`̕ɕϊ郁\bhB
	 * 
	 * @param textA
	 * @param textB
	 * @param results
	 * @return
	 */
	public static String convertLine(String textA, String textB, DiffResult[] results) {
		
		String ret = null;
		DiffResult result = null;
		String[] strA = splitLine(textA);
		String[] strB = splitLine(textB);
		for(int i = (results.length - 1); i >= 0; i--) {
			result = results[i];
			if(result.Modified == false) {
				continue;
			}

			if(result.isModified()) {
				for(int j = result.OriginalStart; j < result.OriginalEnd; j++) {
					strA[j] = 
						"<strike STYLE=\"background:#FFE6E6;\">" +
						strA[j] +
						"</strike>";
				}
				for(int j = result.ModifiedStart; j < result.ModifiedEnd; j++) {
					System.out.println(i + "  Len = " + strB.length +"  >>> " + result.ModifiedEnd);
					strB[j] = 
						"<INS STYLE=\"background:#E6FFE6;\"><font color=\"red\">" +
						strB[j] +
						"</font></INS>";
				}
			} else if(result.isDelete()) {
				for(int j = result.OriginalStart; j < result.OriginalEnd; j++) {
					strA[j] = 
						"<strike STYLE=\"background:#FFE6E6;\">" +
						strA[j] +
						"</strike>";
				}
			} else {
				for(int j = result.ModifiedStart; j < result.ModifiedEnd; j++) {
					strB[j] = 
						"<INS STYLE=\"background:#E6FFE6;\"><font color=\"red\">" +
						strB[j] +
						"</font></INS>";
				}
			}
		}
		
		StringBuffer stb = new StringBuffer("<HTML>\n<HEAD>\n</HEAD>\n<BODY>\nύXOF<BR>");
		for(int i = 0; i < strA.length; i++) {
			stb.append("@").append(strA[i]).append("<BR>\n");
		}
		stb.append("<BR><BR>ύXF<BR>");
		
		for(int i = 0; i < strB.length; i++) {
			stb.append("@").append(strB[i]).append("<BR>\n");
		}
		stb.append("</BODY>\n</HTML>");
		ret = stb.toString();
		
		return ret;
	}

	/**
	 * DIFFʂP̏ɁA̓f[^̑Ώۉӏ
	 * HTML`̕ɒuB
	 * C폜ꂽC֕\ׂ̒usB
	 * 
	 * @param data
	 * @param result
	 * @param delFlg
	 * @return
	 */
	private static String replaceOrgInfo(String textA, String textB, DiffResult result) {

		String repData = null;
		int fromIndex = 0;
		int toIndex = 0;
		StringBuffer convData = new StringBuffer();
		fromIndex = result.OriginalStart;
		toIndex = result.OriginalStart + result.OriginalLength;
		
		if(result.isDelete()) {
			repData = "<strike STYLE=\"background:#FFE6E6;\">" + textA.substring(fromIndex, toIndex) + "</strike>";
			convData.
				append(textB.substring(0, result.ModifiedStart)).
				append(repData).
				append(textB.substring(result.ModifiedStart, textB.length()));
		} else {
			repData = "<strike STYLE=\"background:#99FFFF;\">" + textA.substring(fromIndex, toIndex) + "</strike>";
			convData.
				append(textB.substring(0, result.ModifiedStart + result.ModifiedLength)).
				append(repData).
				append(textB.substring(result.ModifiedStart + result.ModifiedLength, textB.length()));
		}


		return convData.toString();
	}

	/**
	 * DIFFʂP̏ɁA̓f[^̑Ώۉӏ
	 * HTML`̕ɒuB
	 * Cɒǉ^Csꂽӏ̕\𔽉f܂B
	 * 
	 * @param data
	 * @param result
	 * @param delFlg
	 * @return
	 */
	private static String replaceToInfo(String data, DiffResult result) {

		String repData = null;
		int fromIndex = 0;
		int toIndex = 0;
		fromIndex = result.ModifiedStart;
		toIndex = result.ModifiedStart + result.ModifiedLength;
		if(result.isModified()) {
			repData = "<INS STYLE=\"background:#66FFFF;\"><font color=\"red\">" + data.substring(fromIndex, toIndex) + "</font></INS>";
		} else {
			repData = "<INS STYLE=\"background:#E6FFE6;\"><font color=\"red\">" + data.substring(fromIndex, toIndex) + "</font></INS>";
		}

		StringBuffer convData = new StringBuffer(data);
		convData.replace(fromIndex, toIndex, repData);

		return convData.toString();
	}
	
	/**
	 * DIFFʂP̏ɁA̓f[^̑Ώۉӏ
	 * HTML`̕ɒuB
	 * 
	 * @param data
	 * @param result
	 * @param delFlg
	 * @return
	 */
	private static String replaceItem(String data, DiffResult result, boolean delFlg) {

		String repData = null;
		int fromIndex = 0;
		int toIndex = 0;
		if(delFlg) {
			fromIndex = result.OriginalStart;
			toIndex = result.OriginalStart + result.OriginalLength;
			repData = "<strike STYLE=\"background:#FFE6E6;\">" + data.substring(fromIndex, toIndex) + "</strike>";

		} else {
			fromIndex = result.ModifiedStart;
			toIndex = result.ModifiedStart + result.ModifiedLength;
			if(result.isModified()) {
				repData = "<INS STYLE=\"background:#66FFFF;\"><font color=\"red\">" + data.substring(fromIndex, toIndex) + "</font></INS>";
			} else {
				repData = "<INS STYLE=\"background:#E6FFE6;\"><font color=\"red\">" + data.substring(fromIndex, toIndex) + "</font></INS>";
			}
		}

		StringBuffer convData = new StringBuffer(data);
		convData.replace(fromIndex, toIndex, repData);

		return convData.toString();
	}
	
	/**
	 * s\bhB
	 * ŌオsƂ̏ꍇɂ̍s擾̂
	 * String#split\bhgpɓƎɎB
	 * @param text
	 * @return
	 */
	private static String[] splitLine(String text) {

		int index = 0;
		int endIndex = 0;
		List<String> list = new LinkedList<String>();
		while((index < (text.length() - 1))) {
			endIndex = text.indexOf("\r\n", index);
			if(endIndex == -1) {
				endIndex = text.length();
			}
			if(endIndex == (index)) {
				list.add("");
				
			} else {
				list.add(text.substring(index, endIndex));
				
			}
			index = endIndex + 2;
			if(index >= (text.length() - 1)) {
				list.add("");
			}
		}
		
		String[] ret = new String[list.size()];
		for(int i = 0; i < list.size(); i++) {
			ret[i] = list.get(i);
		}
		
		if(ret.length == 0) {
			ret = new String[] { text };
		}
		
		return ret;
	}
}
